<?php

namespace addons\csmtable\library\xcore\xcore\utils;

use think\Config;
use think\Request;
use think\Response;
use think\Url;
use think\View as ViewTemplate;
use think\exception\HttpResponseException;

/**
 * Http 返回的工具类
 */
/**
 * Http 返回的工具类
 */
class XcResponseUtils
{
    public static function error($msg = '', $url = null, $data = '', $wait = 999, array $header = [])
    {
        if (Request::instance()->isAjax()) {
            $result = [
                'code' => 0,
                'msg' => $msg,
                'data' => $data,
                'url' => $url,
                'wait' => $wait
            ];
            echo json_encode($result);
            die();
        } else {
            $type = "html"; //$this->getResponseType();
            $result = [
                'code' => 0,
                'msg'  => $msg,
                'data' => $data,
                'url'  => $url,
                'wait' => $wait,
            ];

            if ('html' == strtolower($type)) {
                $template = Config::get('template');
                $view = Config::get('view_replace_str');

                $result = ViewTemplate::instance($template, $view)
                    ->fetch(Config::get('dispatch_error_tmpl'), $result);
            }

            $response = Response::create($result, $type)->header($header);

            throw new HttpResponseException($response);
        }
    }

    /**
     * Copy from traits\controller\Jump.php#success function
     */
    public static function success($msg = '', $url = null, $data = '', $wait = 3, array $header = [])
    {
        if (is_null($url) && ! is_null(Request::instance()->server('HTTP_REFERER'))) {
            $url = Request::instance()->server('HTTP_REFERER');
        } elseif ('' !== $url && ! strpos($url, '://') && 0 !== strpos($url, '/')) {
            $url = Url::build($url);
        }

        $type = Request::instance()->isAjax() ? Config::get('default_ajax_return') : Config::get('default_return_type');
        $result = [
            'code' => 1,
            'msg' => $msg,
            'data' => $data,
            'url' => $url,
            'wait' => $wait
        ];

        if ('html' == strtolower($type)) {
            $template = Config::get('template');
            $view = Config::get('view_replace_str');

            $result = ViewTemplate::instance($template, $view)->fetch(Config::get('dispatch_success_tmpl'), $result);
        }

        $response = Response::create($result, $type)->header($header);

        throw new HttpResponseException($response);
    }

    public static function redirect($url, $params = [], $code = 302, $with = [])
    {
        if (is_integer($params)) {
            $code = $params;
            $params = [];
        }
        $response = new Redirect($url);
        $response->code($code)
            ->params($params)->with($with);

        throw new HttpResponseException($response);
    }
}